% PACKAGES

\usepackage{fontspec}

\usepackage[russian]{babel}

% BEFORE font packages
\usepackage{amsmath, amsthm, amssymb}
\usepackage{mathtools}
\usepackage{centernot}
\usepackage{bm}

\usepackage{accents}

%\usepackage{ebgaramond}
%\usepackage[cmintegrals,cmbraces]{newtxmath}
%\usepackage{ebgaramond-maths}

\usepackage{libertinus}

%\setmainfont{Libertinus Serif}
%\setmathfont{Libertinus Math}
%\setmonofont{Libertinus Sans}

\usepackage{hyphenat}
\hyphenation{ма-те-ма-ти-ка вос-ста-нав-ли-вать}  % Transition rules

\usepackage{tocloft}

\usepackage{hyperref}
\hypersetup{
  colorlinks,
}

\usepackage{geometry}

\usepackage{import}
\usepackage{xifthen}
\usepackage{pdfpages}
\usepackage{transparent}

\usepackage{graphicx}
\graphicspath{ {./figures/} }

\usepackage{xargs}

\usepackage{parskip}

\usepackage{marginnote}

\usepackage{todonotes}

\usepackage{graphicx}

\usepackage{thmtools}
\usepackage{mdframed}

\usepackage{subcaption}

\usepackage{titlesec}

\usepackage{enumitem}

\usepackage{xecyr}
\usepackage[russian]{cleveref}  % after amsmath



% SETTINGS
\geometry{
  a4paper,
  left=20mm,
  right=35mm,  % for margin notes
  marginparwidth=25mm,
  top=25mm,
  bottom=25mm
}

\titleformat{\chapter}[display]
  {\huge\bfseries}
  {Глава \thechapter.}
  {0pt}
  {\Huge\bfseries}
\titlespacing*{\chapter}{0pt}{0pt}{20pt}

\usepackage{fancyhdr}
\pagestyle{fancy}

\fancyhead[RO,LE]{\@lecture} % Right odd,  Left even
\fancyhead[RE,LO]{}          % Right even, Left odd

\fancyfoot[RO,LE]{\thepage}  % Right odd,  Left even
\fancyfoot[RE,LO]{}          % Right even, Left odd
\fancyfoot[C]{\leftmark}     % Center


% COMMANDS
\usepackage{xparse}

\NewDocumentCommand{\incfig}{om}{%
  \IfValueTF{#1}{%
    \def\svgwidth{#1}
  }{%
    \def\svgwidth{\columnwidth}
  }%
  \import{./figures/}{#2.pdf_tex}
}

\DeclareRobustCommand{\divby}{
  \mathrel{\vbox{\baselineskip.65ex\lineskiplimit0pt\hbox{.}\hbox{.}\hbox{.}}}%
}

\def\letus{%
    \mathord{\setbox0=\hbox{$\exists$}%
             \hbox{\kern 0.125\wd0%
                   \vbox to \ht0{%
                      \hrule width 0.75\wd0%
                      \vfill%
                      \hrule width 0.75\wd0}%
                   \vrule height \ht0%
                   \kern 0.125\wd0}%
           }%
}


\newcommand{\listlectures}{Лекции}
\newlistof{lecture}{lec}{\listlectures}

\usepackage{xifthen}
\def\@lecture{}%
\newcommand{\lecture}[3]{
    \refstepcounter{lecture} % increase the TOL counter

    \ifthenelse{\isempty{#3}}{%
        \def\@lecture{Лекция #1}%
    }{%
        \def\@lecture{Лекция #1: #3}%
    }%
    \subsection*{\@lecture}
    \marginpar{\small\textsf{\mbox{#2}}}

    \addcontentsline{lec}{lecture}{\protect\numberline{}\@lecture}
}

\newcommand*\lxor{\oplus}

\newcommand*\bigland{\bigwedge}
\newcommand*\biglor{\bigvee}
\newcommand*\biglxor{\bigoplus}

% https://tex.stackexchange.com/a/235120
\makeatletter
\newcommand*\bcdot{\mathpalette\bcdot@{.6}}
\newcommand*\bcdot@[2]{\mathbin{\vcenter{\hbox{\scalebox{#2}{$\m@th#1\bullet$}}}}}
\makeatother

% https://tex.stackexchange.com/a/60253
\makeatletter
\let\save@mathaccent\mathaccent
\newcommand*\if@single[3]{%
  \setbox0\hbox{${\mathaccent"0362{#1}}^H$}%
  \setbox2\hbox{${\mathaccent"0362{\kern0pt#1}}^H$}%
  \ifdim\ht0=\ht2 #3\else #2\fi
  }
%The bar will be moved to the right by a half of \macc@kerna, which is computed by amsmath:
\newcommand*\rel@kern[1]{\kern#1\dimexpr\macc@kerna}
%If there's a superscript following the bar, then no negative kern may follow the bar;
%an additional {} makes sure that the superscript is high enough in this case:
\newcommand*\widebar[1]{\@ifnextchar^{{\wide@bar{#1}{0}}}{\wide@bar{#1}{1}}}
%Use a separate algorithm for single symbols:
\newcommand*\wide@bar[2]{\if@single{#1}{\wide@bar@{#1}{#2}{1}}{\wide@bar@{#1}{#2}{2}}}
\newcommand*\wide@bar@[3]{%
  \begingroup
  \def\mathaccent##1##2{%
%Enable nesting of accents:
    \let\mathaccent\save@mathaccent
%If there's more than a single symbol, use the first character instead (see below):
    \if#32 \let\macc@nucleus\first@char \fi
%Determine the italic correction:
    \setbox\z@\hbox{$\macc@style{\macc@nucleus}_{}$}%
    \setbox\tw@\hbox{$\macc@style{\macc@nucleus}{}_{}$}%
    \dimen@\wd\tw@
    \advance\dimen@-\wd\z@
%Now \dimen@ is the italic correction of the symbol.
    \divide\dimen@ 3
    \@tempdima\wd\tw@
    \advance\@tempdima-\scriptspace
%Now \@tempdima is the width of the symbol.
    \divide\@tempdima 10
    \advance\dimen@-\@tempdima
%Now \dimen@ = (italic correction / 3) - (Breite / 10)
    \ifdim\dimen@>\z@ \dimen@0pt\fi
%The bar will be shortened in the case \dimen@<0 !
    \rel@kern{0.6}\kern-\dimen@
    \if#31
      \overline{\rel@kern{-0.6}\kern\dimen@\macc@nucleus\rel@kern{0.4}\kern\dimen@}%
      \advance\dimen@0.4\dimexpr\macc@kerna
%Place the combined final kern (-\dimen@) if it is >0 or if a superscript follows:
      \let\final@kern#2%
      \ifdim\dimen@<\z@ \let\final@kern1\fi
      \if\final@kern1 \kern-\dimen@\fi
    \else
      \overline{\rel@kern{-0.6}\kern\dimen@#1}%
    \fi
  }%
  \macc@depth\@ne
  \let\math@bgroup\@empty \let\math@egroup\macc@set@skewchar
  \mathsurround\z@ \frozen@everymath{\mathgroup\macc@group\relax}%
  \macc@set@skewchar\relax
  \let\mathaccentV\macc@nested@a
%The following initialises \macc@kerna and calls \mathaccent:
  \if#31
    \macc@nested@a\relax111{#1}%
  \else
%If the argument consists of more than one symbol, and if the first token is
%a letter, use that letter for the computations:
    \def\gobble@till@marker##1\endmarker{}%
    \futurelet\first@char\gobble@till@marker#1\endmarker
    \ifcat\noexpand\first@char A\else
      \def\first@char{}%
    \fi
    \macc@nested@a\relax111{\first@char}%
  \fi
  \endgroup
}
\makeatother

\newcommand*\mnote[1]{\marginnote{\footnotesize #1}}

\newcommandx{\unsure}[2][1=]{\todo[size=\small,linecolor=red,#1]{#2}}

\makeatletter
\newcommand{\mlink}{%
  \begingroup
  \@makeother\%\@makeother\#%
  \@makemarginhref
}
\def\@makemarginhref#1#2{%
  \mnote{\href{#1}{#2}}%
  \endgroup
}
\makeatother

\usepackage{graphicx}  % FIXME
\newcommand\smallO{
  \mathchoice
    {{\scriptstyle\mathcal{O}}}% \displaystyle
    {{\scriptstyle\mathcal{O}}}% \textstyle
    {{\scriptscriptstyle\mathcal{O}}}% \scriptstyle
    {\scalebox{.7}{$\scriptscriptstyle\mathcal{O}$}}%\scriptscriptstyle
}

\newcommand\bigO{\mathcal{O}}

\newcounter{saveenumi}
\newcommand{\savei}{\setcounter{saveenumi}{\value{enumi}}}
\newcommand{\conti}{\setcounter{enumi}{\value{saveenumi}}}

\newcommand\bref[3][blue]{%
    \begingroup%
    \hypersetup{linkcolor=#1}%
    \hyperlink{#2}{#3}%
    \endgroup}

\newcommand\N{\ensuremath{\mathbb{N}}}
\newcommand\R{\ensuremath{\mathbb{R}}}
\newcommand\Z{\ensuremath{\mathbb{Z}}}
\renewcommand\O{\ensuremath{\varnothing}}
\newcommand\Q{\ensuremath{\mathbb{Q}}}
\newcommand\C{\ensuremath{\mathbb{C}}}
\renewcommand\H{\ensuremath{\mathbb{H}}}

\newcommand\divs{\ensuremath{\mid}}
\newcommand\ndivs{\ensuremath{\nmid}}

\newcommand{\symdiff}{\mathbin{\triangle}}
\newcommand{\notimplies}{\ensuremath{\centernot\implies}}

\DeclareMathOperator{\End}{End}
\DeclareMathOperator{\dom}{dom}
\DeclareMathOperator{\rnd}{rnd}
\DeclareMathOperator{\id}{id}
\DeclareMathOperator{\Imf}{Im}
\DeclareMathOperator{\Ker}{Ker}
\DeclareMathOperator{\Frac}{Frac}
\DeclareMathOperator{\ord}{ord}
\DeclareMathOperator{\ev}{ev}
\DeclareMathOperator{\Char}{Char}
\DeclareMathOperator{\Hom}{Hom}

\DeclareMathOperator{\sgn}{sgn}

\newcommand{\ubar}[1]{\underaccent{\bar}{#1}}

\newcommand{\mat}[1]{\mathbf{#1}}

\newcommand{\injto}[2][]{\xhookrightarrow[#1]{#2}}
\newcommand{\surjto}[2][]{%
  \xrightarrow[#1]{#2}\mathrel{\mkern-12mu}\rightarrow
}
\newcommand{\bijto}[2][]{%
  \mathrel{\mathrlap{\xhookrightarrow[#1]{#2}}}\mathrel{\mkern2mu\surjto}
}

% https://tex.stackexchange.com/a/265742
\newlength{\oversymawd}
\newlength{\oversymbwd}
\newcommand{\oversym}[2]{
  \settowidth{\oversymawd}%
  {\({{}_{\mathrm{#2}}}\)}\settowidth{\oversymbwd}{\(#1\)}%
  \addtolength{\oversymawd}{-\oversymbwd}%
  \leavevmode\ifthenelse{\lengthtest{\oversymawd>0pt}}%
  {\kern-.5\oversymawd}{}\mathrel{\mathop{#1}\limits^{#2}}%
}

\newcommand*\df{\mathop{}\!\mathrm{d}}
\newcommand*\Df[1]{\mathop{}\!\mathrm{d^#1}}

% ENVIRONMENTS
\theoremstyle{definition}

\renewcommand\qedsymbol{$\blacksquare$}

% https://tex.stackexchange.com/a/290019
\usepackage{etoolbox}

\newcounter{prooflocalequations}
\newcounter{proofglobalequations}

\AtBeginEnvironment{proof}{\setcounter{prooflocalequations}{\value{equation}}
\refstepcounter{proofglobalequations}
\setcounter{equation}{0}\renewcommand{\theequation}{\alph{equation}}
\renewcommand{\theHequation}{\arabic{proofglobalequations}.\alph{equation}}}
\AtEndEnvironment{proof}{\setcounter{equation}{\value{prooflocalequations}}}

\declaretheoremstyle[
  numbered=no,
  qed=$\lrcorner$
]{mystyle}

\declaretheorem[name=Теорема, style=mystyle]{theorem}
\declaretheorem[name=Лемма, style=mystyle]{lemma}
\declaretheorem[name=Определение, style=mystyle]{definition}
\declaretheorem[name=Пример, style=mystyle]{example}
\declaretheorem[name=Примечание, style=mystyle]{note}
\declaretheorem[name=Обозначение, style=mystyle]{notation}
\declaretheorem[name=Утверждение, style=mystyle]{statement}
\declaretheorem[name=Замечание, style=mystyle]{remark}
\declaretheorem[name=Упражнение, style=mystyle]{exercise}
\declaretheorem[name=Следствие, style=mystyle]{consequence}
\declaretheorem[name=Аксиома]{axiom}
\declaretheorem[name=Предложение, style=mystyle]{proposition}


\newcommand{\pfpartsdot}[1]{{\normalfont\slshape\sffamily #1.}}
\newlist{pfparts}{description}{1}
\setlist[pfparts, 1]{%
  font=\pfpartsdot,
  itemindent=0pt,
  wide,
  itemsep=0pt,topsep=2pt,
  labelindent=\parindent,
}

\author{Чередник Давид}
